## apr 1.5.1

=== CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Read README.cmake before using this.

PROJECT(APR C)

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

OPTION(APR_INSTALL_PRIVATE_H  "Install selected private .h files (for httpd)"  OFF)
OPTION(APR_HAVE_IPV6        "IPv6 support"                 ON)
OPTION(INSTALL_PDB          "Install .pdb files (if generated)"  ON)
OPTION(APR_BUILD_TESTAPR    "Build the test suite"         OFF)
OPTION(TEST_STATIC_LIBS     "Test programs use APR static libraries instead of shared libraries?" OFF)
SET(MIN_WINDOWS_VER             "Vista" 
    CACHE STRING "Minimum Windows version")

# create 1-or-0 representation of feature tests for apr.h

SET(apr_have_ipv6_10 0)

IF(APR_HAVE_IPV6)
  SET(apr_have_ipv6_10 1)
ENDIF()

IF("${MIN_WINDOWS_VER}" STREQUAL "")
  SET(win32_winnt_str "0x0600")
ELSEIF(${MIN_WINDOWS_VER} STREQUAL "Vista")
  SET(win32_winnt_str "0x0600")
ELSEIF(${MIN_WINDOWS_VER} STREQUAL "Windows7")
  SET(win32_winnt_str "0x0601")
ELSE()
  SET(win32_winnt_str ${MIN_WINDOWS_VER})
ENDIF()

CONFIGURE_FILE(include/apr.hwc
               ${PROJECT_BINARY_DIR}/apr.h)

ADD_EXECUTABLE(gen_test_char tools/gen_test_char.c)
GET_TARGET_PROPERTY(GEN_TEST_CHAR_EXE gen_test_char LOCATION)
ADD_CUSTOM_COMMAND(
  COMMENT "Generating character tables, apr_escape_test_char.h, for current locale"
  DEPENDS gen_test_char
  COMMAND ${GEN_TEST_CHAR_EXE} > ${PROJECT_BINARY_DIR}/apr_escape_test_char.h
  OUTPUT ${PROJECT_BINARY_DIR}/apr_escape_test_char.h
)
ADD_CUSTOM_TARGET(
  test_char_header ALL
  DEPENDS ${PROJECT_BINARY_DIR}/apr_escape_test_char.h
)

# Generated .h files are stored in PROJECT_BINARY_DIR, not the
# source tree.
#
# BROKEN: not searching PROJECT_BINARY_DIR first, so you have to
#         manually delete apr.h in PROJECT_SOURCE_DIR/include if
#         you've generated apr.h before using a different build

SET(APR_INCLUDE_DIRECTORIES
  ${PROJECT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}/include/arch/win32
  ${CMAKE_CURRENT_SOURCE_DIR}/include/arch/unix
  ${CMAKE_CURRENT_SOURCE_DIR}/include/private
)

SET(APR_SYSTEM_LIBS
  ws2_32
  mswsock
  rpcrt4
)

INCLUDE_DIRECTORIES(${APR_INCLUDE_DIRECTORIES})

SET(APR_PUBLIC_HEADERS_STATIC
  include/apr_allocator.h
  include/apr_atomic.h
  include/apr_dso.h
  include/apr_env.h
  include/apr_errno.h
  include/apr_escape.h
  include/apr_file_info.h
  include/apr_file_io.h
  include/apr_fnmatch.h
  include/apr_general.h
  include/apr_getopt.h
  include/apr_global_mutex.h
  include/apr_hash.h
  include/apr_inherit.h
  include/apr_lib.h
  include/apr_mmap.h
  include/apr_network_io.h
  include/apr_poll.h
  include/apr_pools.h
  include/apr_portable.h
  include/apr_proc_mutex.h
  include/apr_random.h
  include/apr_ring.h
  include/apr_shm.h
  include/apr_signal.h
  include/apr_skiplist.h
  include/apr_strings.h
  include/apr_support.h
  include/apr_tables.h
  include/apr_thread_cond.h
  include/apr_thread_mutex.h
  include/apr_thread_proc.h
  include/apr_thread_rwlock.h
  include/apr_time.h
  include/apr_user.h
  include/apr_version.h
  include/apr_want.h
)
SET(APR_PUBLIC_HEADERS_GENERATED
  ${PROJECT_BINARY_DIR}/apr.h
)

SET(APR_SOURCES
  atomic/win32/apr_atomic.c
  dso/win32/dso.c
  encoding/apr_escape.c
  file_io/unix/copy.c
  file_io/unix/fileacc.c
  file_io/unix/filepath_util.c
  file_io/unix/fullrw.c
  file_io/unix/mktemp.c
  file_io/unix/tempdir.c
  file_io/win32/buffer.c
  file_io/win32/dir.c
  file_io/win32/filedup.c
  file_io/win32/filepath.c
  file_io/win32/filestat.c
  file_io/win32/filesys.c
  file_io/win32/flock.c
  file_io/win32/open.c
  file_io/win32/pipe.c
  file_io/win32/readwrite.c
  file_io/win32/seek.c
  locks/win32/proc_mutex.c
  locks/win32/thread_cond.c
  locks/win32/thread_mutex.c
  locks/win32/thread_rwlock.c
  memory/unix/apr_pools.c
  misc/unix/errorcodes.c
  misc/unix/getopt.c
  misc/unix/otherchild.c
  misc/unix/version.c
  misc/win32/charset.c
  misc/win32/env.c
  misc/win32/internal.c
  misc/win32/misc.c
  misc/win32/rand.c
  misc/win32/start.c
  misc/win32/utf8.c
  mmap/unix/common.c
  mmap/win32/mmap.c
  network_io/unix/inet_ntop.c
  network_io/unix/inet_pton.c
  network_io/unix/multicast.c
  network_io/unix/sockaddr.c
  network_io/unix/socket_util.c
  network_io/win32/sendrecv.c
  network_io/win32/sockets.c
  network_io/win32/sockopt.c
  passwd/apr_getpass.c
  poll/unix/poll.c
  poll/unix/pollcb.c
  poll/unix/pollset.c
  poll/unix/select.c
  random/unix/apr_random.c
  random/unix/sha2.c
  random/unix/sha2_glue.c
  shmem/win32/shm.c
  strings/apr_cpystrn.c
  strings/apr_fnmatch.c
  strings/apr_snprintf.c
  strings/apr_strings.c
  strings/apr_strnatcmp.c
  strings/apr_strtok.c
  tables/apr_hash.c
  tables/apr_skiplist.c
  tables/apr_tables.c
  threadproc/win32/proc.c
  threadproc/win32/signals.c
  threadproc/win32/thread.c
  threadproc/win32/threadpriv.c
  time/win32/time.c
  time/win32/timestr.c
  user/win32/groupinfo.c
  user/win32/userinfo.c
)

SET(APR_TEST_SOURCES
  test/abts.c
  test/testargs.c
  test/testatomic.c
  test/testcond.c
  test/testdir.c
  test/testdso.c
  test/testdup.c
  test/testenv.c
  test/testescape.c
  test/testfile.c
  test/testfilecopy.c
  test/testfileinfo.c
  test/testflock.c
  test/testfmt.c
  test/testfnmatch.c
  test/testglobalmutex.c
  test/testhash.c
  test/testipsub.c
  test/testlfs.c
  test/testlock.c
  test/testmmap.c
  test/testnames.c
  test/testoc.c
  test/testpath.c
  test/testpipe.c
  test/testpoll.c
  test/testpools.c
  test/testproc.c
  test/testprocmutex.c
  test/testrand.c
  test/testshm.c
  test/testsleep.c
  test/testsock.c
  test/testsockets.c
  test/testsockopt.c
  test/teststr.c
  test/teststrnatcmp.c
  test/testtable.c
  test/testtemp.c
  test/testthread.c
  test/testtime.c
  test/testud.c
  test/testuser.c
  test/testutil.c
  test/testvsn.c
)

SET(install_targets)
SET(install_bin_pdb)
SET(install_lib_pdb)

# libapr-1 is shared, apr-1 is static
ADD_LIBRARY(libapr-1 SHARED ${APR_SOURCES} ${APR_PUBLIC_HEADERS_GENERATED} libapr.rc)
SET(install_targets ${install_targets} libapr-1)
SET(install_bin_pdb ${install_bin_pdb} ${PROJECT_BINARY_DIR}/libapr-1.pdb)
TARGET_LINK_LIBRARIES(libapr-1 ${APR_SYSTEM_LIBS})
SET_TARGET_PROPERTIES(libapr-1 PROPERTIES COMPILE_DEFINITIONS "APR_DECLARE_EXPORT;WINNT")
ADD_DEPENDENCIES(libapr-1 test_char_header)

ADD_LIBRARY(apr-1 STATIC ${APR_SOURCES} ${APR_PUBLIC_HEADERS_GENERATED})
SET(install_targets ${install_targets} apr-1)
SET(install_lib_pdb ${install_lib_pdb} ${PROJECT_BINARY_DIR}/apr-1.pdb)
TARGET_LINK_LIBRARIES(apr-1 ${APR_SYSTEM_LIBS})
SET_TARGET_PROPERTIES(apr-1 PROPERTIES COMPILE_DEFINITIONS "APR_DECLARE_STATIC;WINNT")
ADD_DEPENDENCIES(apr-1 test_char_header)

# libaprapp-1 and aprapp-1 are static
ADD_LIBRARY(libaprapp-1 STATIC misc/win32/apr_app.c misc/win32/internal.c ${APR_PUBLIC_HEADERS_GENERATED})
SET(install_targets ${install_targets} libaprapp-1)
SET(install_lib_pdb ${install_lib_pdb} ${PROJECT_BINARY_DIR}/libaprapp-1.pdb)
SET_TARGET_PROPERTIES(libaprapp-1 PROPERTIES COMPILE_DEFINITIONS "APR_APP;WINNT")

ADD_LIBRARY(aprapp-1 STATIC misc/win32/apr_app.c misc/win32/internal.c ${APR_PUBLIC_HEADERS_GENERATED})
SET(install_targets ${install_targets} aprapp-1)
SET(install_lib_pdb ${install_lib_pdb} ${PROJECT_BINARY_DIR}/aprapp-1.pdb)
SET_TARGET_PROPERTIES(aprapp-1 PROPERTIES COMPILE_DEFINITIONS "APR_DECLARE_STATIC;APR_APP;WINNT")

IF(APR_BUILD_TESTAPR)
  ENABLE_TESTING()
  # Create a "check" target that displays test program output to the console.
  ADD_CUSTOM_TARGET(check COMMAND ${CMAKE_CTEST_COMMAND} --verbose)

  # copy data files to build directory so that we can run programs from there
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E make_directory 
                  ${PROJECT_BINARY_DIR}/data)
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E copy_if_different 
                  ${PROJECT_SOURCE_DIR}/test/data/file_datafile.txt
                  ${PROJECT_BINARY_DIR}/data/file_datafile.txt)
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E copy_if_different
                  ${PROJECT_SOURCE_DIR}/test/data/mmap_datafile.txt
                  ${PROJECT_BINARY_DIR}/data/mmap_datafile.txt)

  IF(TEST_STATIC_LIBS)
    SET(whichapr    apr-1)
    SET(whichaprapp aprapp-1)
    SET(apiflag     -DAPR_DECLARE_STATIC)
  ELSE()
    SET(whichapr    libapr-1)
    SET(whichaprapp libaprapp-1)
    SET(apiflag)
  ENDIF()

  ADD_EXECUTABLE(testapp test/testapp.c)
  TARGET_LINK_LIBRARIES(testapp ${whichapr} ${whichaprapp} ${APR_SYSTEM_LIBS})
  SET_TARGET_PROPERTIES(testapp PROPERTIES LINK_FLAGS /entry:wmainCRTStartup)
  IF(apiflag)
    SET_TARGET_PROPERTIES(testapp PROPERTIES COMPILE_FLAGS ${apiflag})
  ENDIF()
  ADD_TEST(NAME testapp COMMAND testapp)

  ADD_EXECUTABLE(testall ${APR_TEST_SOURCES})
  TARGET_LINK_LIBRARIES(testall ${whichapr} ${APR_SYSTEM_LIBS})
  IF(apiflag)
    SET_TARGET_PROPERTIES(testall PROPERTIES COMPILE_FLAGS ${apiflag})
  ENDIF()
  ADD_TEST(NAME testall COMMAND testall)

  ADD_LIBRARY(mod_test MODULE test/mod_test.c)
  TARGET_LINK_LIBRARIES(mod_test ${whichapr} ${APR_SYSTEM_LIBS})
  SET_PROPERTY(TARGET mod_test APPEND PROPERTY LINK_FLAGS /export:print_hello)
  # nasty work-around for difficulties adding more than one additional flag
  # (they get joined in a bad way behind the scenes)
  GET_PROPERTY(link_flags TARGET mod_test PROPERTY LINK_FLAGS)
  SET(link_flags "${link_flags} /export:count_reps")
  SET_TARGET_PROPERTIES(mod_test PROPERTIES LINK_FLAGS ${link_flags})
  IF(apiflag)
    SET_TARGET_PROPERTIES(mod_test PROPERTIES COMPILE_FLAGS ${apiflag})
  ENDIF()

  # Build all the single-source executable files with no special build
  # requirements.
  SET(single_source_programs
    test/echod.c
    test/sendfile.c
    test/sockperf.c
    test/testlockperf.c
    test/testmutexscope.c
    test/globalmutexchild.c
    test/occhild.c
    test/proc_child.c
    test/readchild.c
    test/sockchild.c
    test/testshmproducer.c
    test/testshmconsumer.c
    test/tryread.c
    test/internal/testucs.c
  )

  FOREACH(sourcefile ${single_source_programs})
    STRING(REGEX REPLACE ".*/([^\\]+)\\.c" "\\1" proggie ${sourcefile})
    ADD_EXECUTABLE(${proggie} ${sourcefile})
    TARGET_LINK_LIBRARIES(${proggie} ${whichapr} ${APR_SYSTEM_LIBS})
    IF(apiflag)
      SET_TARGET_PROPERTIES(${proggie} PROPERTIES COMPILE_FLAGS ${apiflag})
    ENDIF()
  ENDFOREACH()

  # Add tests for programs that run by themselves with no arguments.
  SET(simple_tests
    testmutexscope
    testucs
  )

  FOREACH(simple ${simple_tests})
    ADD_TEST(NAME ${simple} COMMAND ${simple})
  ENDFOREACH()

  # testlockperf takes forever on Windows with default counter limit
  ADD_TEST(NAME testlockperf COMMAND testlockperf -c 50000)

  # sendfile runs multiple times with different parameters.
  FOREACH(sendfile_mode blocking nonblocking timeout)
    ADD_TEST(NAME sendfile-${sendfile_mode} COMMAND sendfile client ${sendfile_mode} startserver)
  ENDFOREACH()

  # No test is added for echod+sockperf.  Those will have to be run manually.

ENDIF (APR_BUILD_TESTAPR)

# Installation

INSTALL(TARGETS ${install_targets}
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
       )

IF(INSTALL_PDB)
  INSTALL(FILES ${install_bin_pdb}
          DESTINATION bin

## apr 1.4.6

=== debian/changelog ===
apr (1.4.6-3ubuntu1) raring; urgency=low

  * Make APR more cross-build friendly by fixing/mangling a few things:
    - Fix the confusion between HOST and BUILD variables in rules.
    - Fix a thinko using shell-style subshells instead of make-style.
    - Don't try to run native ino_t_test.c when cross-compiling.
    - Add a set of autoconf preseeds that are only used when crossing.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 05 Dec 2012 06:49:57 -0700

apr (1.4.6-3) unstable; urgency=low

  * Fix some issues with resolving loopback addresses of a protocol family
    that is not otherwise configured on a host. Many thanks to Jean-Michel
    Vourgère and Aurelien Jarno for debugging this.
    Closes: #500558, #629899 LP: #397393
  * Pull updates from upstream branch 1.4.x up to r1343251
  * Add some debug output in order to debug test failures on kfreebsd-i386.

 -- Stefan Fritsch <sf@debian.org>  Mon, 28 May 2012 16:02:12 +0200

apr (1.4.6-2) unstable; urgency=low

  * Enable use of some new APIs. The minimal required linux kernel version is
    now 2.6.28.
  * Improvements for Hurd (closes: #656880):
    - Re-enable test suite
    - Update build hints, disable non-working shm and flock methods. Thanks to
      Pino Toscano for the patches.
  * Switch VCS to git.
  * Switch to source format 3.0, debhelper 9. Thanks to Jari Aalto for the
    patch. Closes: #664299
  * Remove sendfile LFS patch that was only necessary for 2.4 kernels.
  * Fix some lintian warnings (dh_prep, build-indep/build-arch targets).
  * Bump Standards-Version (no changes).

 -- Stefan Fritsch <sf@debian.org>  Sun, 20 May 2012 21:39:17 +0200

apr (1.4.6-1) unstable; urgency=low

  * New upstream release:
    - Fixes apr_file_trunc() bug which could lead to subversion repository
      corruption. Closes: #664451
    - Adds randomization to hashes. CVE-2012-0840 (but not known to be
      exploitable in httpd or svn). Closes: #655435
  * Remove Tollef Fog Heen and Ryan Niebur from uploaders. Thanks for your
    work in the past.

 -- Stefan Fritsch <sf@debian.org>  Sun, 18 Mar 2012 23:22:59 +0100

apr (1.4.5-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Disable robust pthread mutexes on armhf causes testprocmutex to hang on
    non-SMP cores. (Closes: #650350)

 -- Hector Oron <zumbi@debian.org>  Thu, 01 Dec 2011 00:04:08 +0000

apr (1.4.5-1) unstable; urgency=high

  * New upstream version:
    - Fix regression introduced by fix for CVE-2011-0419: apr_fnmatch may
      consume 100% CPU. CVE-2011-1928. Closes: #627182
  * Fix allocator using mmap crashing on non-4k-page platforms. Thanks to
    Lifeng Sun for the patch. Closes: #627532 

 -- Stefan Fritsch <sf@debian.org>  Sat, 21 May 2011 20:49:17 +0200

apr (1.4.4-1) unstable; urgency=low

  * New upstream release.
    - Fix potential DoS in apr_fnmatch (CVE-2011-0419)
  * Enable experimental allocator using mmap instead of malloc. This makes
    Apache HTTPD's MaxMemFree directive actually work and hopefully reduces
    memory fragmentation.
  * Bump standards-version (no changes).
  * Reword some short descriptions to make lintian happy.

 -- Stefan Fritsch <sf@debian.org>  Thu, 12 May 2011 22:43:36 +0200

apr (1.4.2-8) unstable; urgency=low

  * Fix apr_ino_t changing size depending on -D_FILE_OFFSET_BITS on
    kfreebsd-*. Closes: #616323

 -- Stefan Fritsch <sf@debian.org>  Sat, 05 Mar 2011 21:14:02 +0100

apr (1.4.2-7) unstable; urgency=low

  * Add a workaround for a problem related to strict aliasing that causes
    gcc 4.5 to create incorrect code in some cases. Closes: #609163
    LP: #697105
  * Bump standards version to 3.9.1:
    - empty dependency_libs section in libapr-1.la

 -- Stefan Fritsch <sf@debian.org>  Sat, 05 Feb 2011 18:22:58 +0100

apr (1.4.2-6) unstable; urgency=low

  * Also disable robust pthread mutexes on alpha, to fix hang in the test
    suite on Linux 2.6.32.

 -- Stefan Fritsch <sf@debian.org>  Mon, 30 Aug 2010 23:42:23 +0200

apr (1.4.2-5) unstable; urgency=medium

  * Fix FTBFS on armel: Disable robust pthread mutexes on armel, as they
    cause a hang in the test suite on Linux 2.6.32.

 -- Stefan Fritsch <sf@debian.org>  Sun, 29 Aug 2010 22:00:11 +0200

apr (1.4.2-4) unstable; urgency=low

  * Fix building with libtool 1.x. Closes: #575380
  * Fix pool life-time issue with apr_socket_addr_get(), resulting in a memory
    leak in Apache mod_proxy.
  * Under Linux, if configure does not detect POSIX semaphores due to /dev/shm
    not being mounted, abort the build. Closes: #591286

 -- Stefan Fritsch <sf@debian.org>  Tue, 17 Aug 2010 23:16:56 +0200

apr (1.4.2-3) unstable; urgency=low

  * Upload to unstable.

 -- Stefan Fritsch <sf@debian.org>  Sun, 31 Jan 2010 10:56:45 +0100

apr (1.4.2-2) experimental; urgency=low

  * Fix FTBFS on kfreebsd: Create os specific symbols file: With *_epoll on
    linux, with *_kqueue on kfreebsd, with neither on hurd.
  * Bump Standards-Version:
    - In the rules file, use the DEB_*_ARCH* instead of the DEB_*_GNU*
      variables, where applicable.

 -- Stefan Fritsch <sf@debian.org>  Thu, 28 Jan 2010 20:28:07 +0100

apr (1.4.2-1) experimental; urgency=low

  [ Stefan Fritsch ]
  * New upstream release
  * Enable use of O_CLOEXEC. This raises the minimum required kernel version
    to 2.6.23. Disable the other new APIs (which would require 2.6.27 or
    2.6.28) by using configure flags instead of patching the source.

  [ Peter Samuelson ]
  * Apply patch from Nobuhiro Iwamatsu to disable some pthread
    functionality on SH4.  (Closes: #549153)

 -- Stefan Fritsch <sf@debian.org>  Thu, 28 Jan 2010 07:33:48 +0100

apr (1.3.8-1) unstable; urgency=high

  [ Stefan Fritsch ]
  * Enable -fstack-protector for arm/armel. A workaround has been added to
    gcc.

  [ Peter Samuelson ]
  * New upstream security release.
    - Fix CVE-2009-2412, overflow in pool allocations due to alignment.

 -- Peter Samuelson <peter@p12n.org>  Thu, 06 Aug 2009 13:00:03 -0500



=== debian/control ===
Source: apr
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
Uploaders: Peter Samuelson <peter@p12n.org>, Stefan Fritsch <sf@debian.org>
Build-Depends: debhelper (>= 9), autoconf, autotools-dev, mawk, uuid-dev, doxygen, netbase, net-tools, libtool (>= 2), python
Standards-Version: 3.9.3
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-apache/apr.git
Vcs-Git: git://git.debian.org/git/pkg-apache/apr.git
Homepage: http://apr.apache.org/

Package: libapr1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libapr1.0
Description: Apache Portable Runtime Library
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 

Package: libapr1-dev
Architecture: any
Section: libdevel
Depends: libapr1 (= ${binary:Version}), uuid-dev, ${misc:Depends}
Suggests: python
Conflicts: libapr1.0-dev, libapr0-dev
Description: Apache Portable Runtime Library - Development Headers
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 This package contains development headers for APR.

Package: libapr1-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libapr1 (= ${binary:Version}), ${misc:Depends}
Description: Apache Portable Runtime Library - Debugging Symbols
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 This package contains the debugging symbols for APR.

=== debian/rules ===
#!/usr/bin/make -f

# Turn on VERBOSE output
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# # from having to guess our platform (since we know it already)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH_BITS  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)

BUILDDIR := build-$(DEB_HOST_ARCH)

CFLAGS := $(CFLAGS) -pipe -Wall -g

# hardening options
H_CFLAGS := -Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector
H_LDFLAGS := -Wl,-z,relro

CONFFLAGS += ac_cv_prog_AWK=mawk apr_cv_sctp=no
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  CONFFLAGS += ac_cv_file__dev_zero=yes \
               ac_cv_func_setpgrp_void=yes \
               apr_cv_epoll=yes \
               ac_cv_struct_rlimit=yes \
               apr_cv_tcp_nodelay_with_cork=yes \
               apr_cv_process_shared_works=yes
  ifeq ($(DEB_HOST_ARCH_BITS),32)
    CONFFLAGS += ac_cv_sizeof_struct_iovec=8
  else ifeq ($(DEB_HOST_ARCH_BITS),64)
    CONFFLAGS += ac_cv_sizeof_struct_iovec=16
  endif
endif

# apr_cv_mutex_robust_shared causes hangs in procmutex test on arm(el|hf) and alpha
# let's just disable this for squeeze
ifneq (,$(findstring armel,$(DEB_HOST_ARCH)))
  CONFFLAGS += apr_cv_mutex_robust_shared=no
endif
ifneq (,$(findstring armhf,$(DEB_HOST_ARCH)))
  CONFFLAGS += apr_cv_mutex_robust_shared=no
endif
ifneq (,$(findstring alpha,$(DEB_HOST_ARCH)))
  CONFFLAGS += apr_cv_mutex_robust_shared=no
endif

# SH4 cannot use proc_pthread.
ifneq (,$(findstring sh4,$(DEB_HOST_ARCH)))
  CONFFLAGS += apr_cv_hasprocpthreadser=no ac_cv_define_PTHREAD_PROCESS_SHARED=no
endif

# Enable debug builds
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
  CFLAGS += -O0
else
  ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    CFLAGS += -O0
  else
    CFLAGS += -O2
  endif
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(NUMJOBS)
endif

ifeq (,$(findstring notest,$(DEB_BUILD_OPTIONS))$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	TEST_TARGET = test
else
	TEST_TARGET =
endif

SHELL=/bin/bash

$(BUILDDIR)/config.status:
	dh_testdir
	mkdir -p $(BUILDDIR)/docs
	./buildconf
	# we need to force the use of bash here. Otherwise, if apr is built with
	# /bin/sh -> /bin/bash, the resulting libtool will not work on systems
	# where /bin/sh -> /bin/dash
	cd $(BUILDDIR) && CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" $(CONFFLAGS) CONFIG_SHELL=/bin/bash /bin/bash ../configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --enable-layout=Debian --includedir=\$${prefix}/usr/include/apr-1.0 --with-installbuilddir=\$${prefix}/usr/share/apr-1.0/build  --enable-nonportable-atomics --enable-allocator-uses-mmap
	# Determine whether upstream's configure gives the same definition of apr_ino_t as we had until 1.2.11-1, but only try when building natively
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	rm -f debian/ino_t_test
	gcc -I$(CURDIR)/include -I$(BUILDDIR)/include `$(BUILDDIR)/apr-1-config --cppflags` -o debian/ino_t_test debian/ino_t_test.c
	debian/ino_t_test
	rm -f debian/ino_t_test
endif
ifeq (hurd, $(DEB_HOST_ARCH_OS))
	# multicast not supported on Hurd
	sed -i '/HAVE_STRUCT_IPMREQ/ d' $(BUILDDIR)/include/arch/unix/apr_private.h
endif
ifeq (linux, $(DEB_HOST_ARCH_OS))
	if grep -q APR_HAS_POSIXSEM_SERIALIZE.*0 $(BUILDDIR)/include/apr.h ;\
	then \
		echo "WARNING: This is Linux but configure did not detect POSIX semaphores." ;\
		if [ "$(shell stat -c '%d' /dev/shm/)" = "$(shell stat -c '%d' /dev/)" ] ;\
		then \
			echo "ERROR: POSIX semaphores not usable and /dev/shm not mounted." ;\
			echo "ERROR: Aborting." ;\
			echo "HINT: If you are using pbuilder or cowbuilder, add /dev/shm to BINDMOUNTS" ;\
			echo "HINT: in pbuilderrc" ;\
			exit 1 ;\
		fi ;\
	fi
endif

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: $(BUILDDIR)/config.status
	dh_testdir

	$(MAKE) -C $(BUILDDIR) CFLAGS="$(H_CFLAGS)" LDFLAGS="$(H_LDFLAGS)"
	$(MAKE) -C $(BUILDDIR) dox

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp test-stamp debian/ino_t_test
	rm -f configure build/lt* build/libtool.m4 build-outputs.mk include/arch/unix/apr_private.h.in
	rm -rf $(BUILDDIR)

	dh_clean

test: test-stamp

# the testsockets test will fail on vservers (no 127.0.0.1) or if ipv6 is
# enabled in the kernel but not configured on any interface
IGNORE_TESTSOCK = $(shell IGN=false; \
	/sbin/ifconfig|grep -q 127.0.0.1 || IGN=true; \
	grep -q ipv6 /proc/net/protocols && ( /sbin/ifconfig|grep -q inet6 || IGN=true ) ; \
	echo $$IGN )

test-stamp: build
	dh_testdir
	$(MAKE) -C $(BUILDDIR)/test all CFLAGS="$(H_CFLAGS)" LDFLAGS="$(H_LDFLAGS)"
	cd $(BUILDDIR)/test && ./testall -v testsockets testsock || $(IGNORE_TESTSOCK)
	cd $(BUILDDIR)/test && ( ulimit -S -s 8192 ; ./testall -v testatomic)
	cd $(BUILDDIR)/test && ./testall -v -x testsockets testsock testatomic
	touch $@

install: build $(TEST_TARGET)
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs -a

	$(MAKE) -C $(BUILDDIR) install DESTDIR=$(CURDIR)/debian/tmp
	perl -p -i -e "s,^dependency_libs=.*,dependency_libs=''," $(CURDIR)/debian/tmp/usr/lib/libapr-1.la

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
	dh_install -a
	dh_installman -plibapr1-dev debian/apr-1-config.1
	dh_link
	dh_strip --dbg-package=libapr1-dbg
	dh_lintian
	dh_compress
	dh_fixperms
	dh_makeshlibs -- -Idebian/symbols.$(DEB_HOST_ARCH_OS)
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## apr 1.4.8

=== debian/changelog ===
apr (1.4.8-1ubuntu1) saucy; urgency=low

  * Merge with Debian; remaining changes:
    - Fix the confusion between HOST and BUILD variables in rules.
    - Fix a thinko using shell-style subshells instead of make-style.
    - Add a set of autoconf preseeds that are only used when cross-building.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 11 Jul 2013 19:08:18 +0200

apr (1.4.8-1) unstable; urgency=low

  * New upstream release
  * Remove the test debug output added in 1.4.6-3. The bug was #673711 in
    eglibc and has been fixed some time ago.

 -- Stefan Fritsch <sf@debian.org>  Thu, 04 Jul 2013 23:25:10 +0200

apr (1.4.6-4) unstable; urgency=low

  * Make the /dev/shm sanity check during build work if it is a symbolic link.
  * Remove the ancient ino_t configure sanity test that causes a FTBFS on x32.
    Closes: #701193
  * Don't override CFLAGS and LDFLAGS during build. This fixes the debug
    information being useless. Closes: #703466

 -- Stefan Fritsch <sf@debian.org>  Sat, 11 May 2013 15:06:24 +0200

=== debian/rules ===
--- 
+++ 
@@ -82,14 +82,7 @@
 	# we need to force the use of bash here. Otherwise, if apr is built with
 	# /bin/sh -> /bin/bash, the resulting libtool will not work on systems
 	# where /bin/sh -> /bin/dash
-	cd $(BUILDDIR) && CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" $(CONFFLAGS) CONFIG_SHELL=/bin/bash /bin/bash ../configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --enable-layout=Debian --includedir=\$${prefix}/usr/include/apr-1.0 --with-installbuilddir=\$${prefix}/usr/share/apr-1.0/build  --enable-nonportable-atomics --enable-allocator-uses-mmap
-	# Determine whether upstream's configure gives the same definition of apr_ino_t as we had until 1.2.11-1, but only try when building natively
-ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
-	rm -f debian/ino_t_test
-	gcc -I$(CURDIR)/include -I$(BUILDDIR)/include `$(BUILDDIR)/apr-1-config --cppflags` -o debian/ino_t_test debian/ino_t_test.c
-	debian/ino_t_test
-	rm -f debian/ino_t_test
-endif
+	cd $(BUILDDIR) && $(CONFFLAGS) CONFIG_SHELL=/bin/bash /bin/bash ../configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --enable-layout=Debian --includedir=\$${prefix}/usr/include/apr-1.0 --with-installbuilddir=\$${prefix}/usr/share/apr-1.0/build  --enable-nonportable-atomics --enable-allocator-uses-mmap
 ifeq (hurd, $(DEB_HOST_ARCH_OS))
 	# multicast not supported on Hurd
 	sed -i '/HAVE_STRUCT_IPMREQ/ d' $(BUILDDIR)/include/arch/unix/apr_private.h
@@ -98,7 +91,7 @@
 	if grep -q APR_HAS_POSIXSEM_SERIALIZE.*0 $(BUILDDIR)/include/apr.h ;\
 	then \
 		echo "WARNING: This is Linux but configure did not detect POSIX semaphores." ;\
-		if [ "$(shell stat -c '%d' /dev/shm/)" = "$(shell stat -c '%d' /dev/)" ] ;\
+		if ! df /dev/shm/.|grep -q ^tmpfs ;\
 		then \
 			echo "ERROR: POSIX semaphores not usable and /dev/shm not mounted." ;\
 			echo "ERROR: Aborting." ;\
@@ -116,7 +109,7 @@
 build-stamp: $(BUILDDIR)/config.status
 	dh_testdir
 
-	$(MAKE) -C $(BUILDDIR) CFLAGS="$(H_CFLAGS)" LDFLAGS="$(H_LDFLAGS)"
+	$(MAKE) -C $(BUILDDIR) CFLAGS="$(H_CFLAGS) $(CFLAGS)" LDFLAGS="$(H_LDFLAGS) $(LDFLAGS)"
 	$(MAKE) -C $(BUILDDIR) dox
 
 	touch $@
@@ -124,7 +117,7 @@
 clean:
 	dh_testdir
 	dh_testroot
-	rm -f build-stamp test-stamp debian/ino_t_test
+	rm -f build-stamp test-stamp
 	rm -f configure build/lt* build/libtool.m4 build-outputs.mk include/arch/unix/apr_private.h.in
 	rm -rf $(BUILDDIR)
 
@@ -141,7 +134,7 @@
 
 test-stamp: build
 	dh_testdir
-	$(MAKE) -C $(BUILDDIR)/test all CFLAGS="$(H_CFLAGS)" LDFLAGS="$(H_LDFLAGS)"
+	$(MAKE) -C $(BUILDDIR)/test all CFLAGS="$(H_CFLAGS) $(CFLAGS)" LDFLAGS="$(H_LDFLAGS) $(LDFLAGS)"
 	cd $(BUILDDIR)/test && ./testall -v testsockets testsock || $(IGNORE_TESTSOCK)
 	cd $(BUILDDIR)/test && ( ulimit -S -s 8192 ; ./testall -v testatomic)
 	cd $(BUILDDIR)/test && ./testall -v -x testsockets testsock testatomic

## apr 1.5.0

=== debian/changelog ===
apr (1.5.0-1) unstable; urgency=low

  * New upstream version
  * Pull changes from upstream 1.5.x branch up to r1552863 to fix problems
    on the FreeBSD 10 kernel with accept4() and non-blocking sockets.

 -- Stefan Fritsch <sf@debian.org>  Mon, 30 Dec 2013 16:37:54 +0100

apr (1.4.8-3) unstable; urgency=low

  * Re-add the logic to force use of bash for configure/libtool. Otherwise,
    if the package is build with /bin/sh -> /bin/bash, the shipped libtool
    won't work on systems with /bin/sh -> /bin/dash. This got lost in
    1.4.8-2. Closes: #730196

 -- Stefan Fritsch <sf@debian.org>  Sat, 23 Nov 2013 00:57:30 +0100

apr (1.4.8-2) unstable; urgency=low

  * Merge some changes from Ubuntu's 1.4.8-1ubuntu1:
    - Fix the confusion between HOST and BUILD variables in rules.
    - Add a set of autoconf preseeds that are only used when cross-building.
  * Change cross-building preseeds to only apply on linux.
  * Cherry-pick fix for O_NONBLOCK configure check from upstream 1.4.x
    branch.
  * Switch build system to dh
    - No longer hard-codes -fstack-protector on unsupported platforms.
      Closes: #717231
    - Bump Standards-Version (no additional changes).
  * Support multi-arch.
  * Enable sctp support on Linux.
  * Change apr_rules.mk to not force CFLAGS, etc. to the values used during
    apr's compilation.
  * Fix accept4() configure test to work on Hurd. Closes: #715028

 -- Stefan Fritsch <sf@debian.org>  Wed, 06 Nov 2013 19:37:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: apr
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
+Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
 Uploaders: Peter Samuelson <peter@p12n.org>, Stefan Fritsch <sf@debian.org>
-Build-Depends: debhelper (>= 9), autoconf, autotools-dev, mawk, uuid-dev, doxygen, netbase, net-tools, libtool (>= 2), python
-Standards-Version: 3.9.3
+Build-Depends: debhelper (>= 9), autoconf, autotools-dev, mawk, uuid-dev, doxygen, netbase, net-tools, libtool (>= 2), python, libsctp-dev [linux-any]
+Standards-Version: 3.9.5
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-apache/apr.git
 Vcs-Git: git://git.debian.org/git/pkg-apache/apr.git
 Homepage: http://apr.apache.org/
@@ -13,6 +12,8 @@
 Package: libapr1
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: same
 Conflicts: libapr1.0
 Description: Apache Portable Runtime Library
  APR is Apache's Portable Runtime Library, designed to be a support library 
@@ -22,7 +23,7 @@
 Package: libapr1-dev
 Architecture: any
 Section: libdevel
-Depends: libapr1 (= ${binary:Version}), uuid-dev, ${misc:Depends}
+Depends: libapr1 (= ${binary:Version}), uuid-dev, ${misc:Depends}, libsctp-dev [linux-any]
 Suggests: python
 Conflicts: libapr1.0-dev, libapr0-dev
 Description: Apache Portable Runtime Library - Development Headers
@@ -36,6 +37,7 @@
 Architecture: any
 Section: debug
 Priority: extra
+Multi-Arch: same
 Depends: libapr1 (= ${binary:Version}), ${misc:Depends}
 Description: Apache Portable Runtime Library - Debugging Symbols
  APR is Apache's Portable Runtime Library, designed to be a support library

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
SHELL=/bin/bash
BUILDDIR := debian/build

DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH_BITS  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# The 'build' target needs special handling because there there is a directory
# named 'build'.
.PHONY: build
build %:
	dh $@ -B$(BUILDDIR) --parallel --with autotools_dev

#
# configure
#
CONFFLAGS := LTFLAGS=--no-silent \
             --host=$(DEB_HOST_GNU_TYPE) \
             --build=$(DEB_BUILD_GNU_TYPE) \
             --enable-layout=Debian \
             --includedir=/usr/include/apr-1.0 \
             --with-installbuilddir=/usr/share/apr-1.0/build \
             --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
             --enable-nonportable-atomics \
             --enable-allocator-uses-mmap \
             ac_cv_prog_AWK=mawk

# apr_cv_mutex_robust_shared causes hangs in procmutex test on arm(el|hf) and alpha
ifneq (,$(findstring armel,$(DEB_HOST_ARCH)))
  CONFFLAGS += apr_cv_mutex_robust_shared=no
endif
ifneq (,$(findstring armhf,$(DEB_HOST_ARCH)))
  CONFFLAGS += apr_cv_mutex_robust_shared=no
endif
ifneq (,$(findstring alpha,$(DEB_HOST_ARCH)))
  CONFFLAGS += apr_cv_mutex_robust_shared=no
endif

# SH4 cannot use proc_pthread.
ifneq (,$(findstring sh4,$(DEB_HOST_ARCH)))
  CONFFLAGS += apr_cv_hasprocpthreadser=no ac_cv_define_PTHREAD_PROCESS_SHARED=no
endif

# multicast not supported on Hurd
ifeq (hurd,$(DEB_HOST_ARCH_OS))
  CONFFLAGS += apr_cv_struct_ipmreq=no
endif

# some minimal cross-building support
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    CONFFLAGS += ac_cv_file__dev_zero=yes \
                 ac_cv_func_setpgrp_void=yes \
                 apr_cv_epoll=yes \
                 ac_cv_struct_rlimit=yes \
                 apr_cv_tcp_nodelay_with_cork=yes \
                 apr_cv_process_shared_works=yes
  endif
  ifeq ($(DEB_HOST_ARCH_BITS),32)
    CONFFLAGS += ac_cv_sizeof_struct_iovec=8
  else ifeq ($(DEB_HOST_ARCH_BITS),64)
    CONFFLAGS += ac_cv_sizeof_struct_iovec=16
  endif
endif

# files that are modified by buildconf and need to be restored during clean
SAVE_FILES := configure build/libtool.m4 build/ltmain.sh

override_dh_auto_configure:
	mkdir -p $(BUILDDIR)/docs
	for f in $(SAVE_FILES) ; do [ -e $$f.dr-orig ] || cp -p $$f $$f.dr-orig ; done
	./buildconf
	# We need to force the use of bash here. Otherwise, if apr is built with
	# /bin/sh -> /bin/bash, the resulting libtool will not work on systems
	# where /bin/sh -> /bin/dash.
	cd $(BUILDDIR) && CONFIG_SHELL=/bin/bash /bin/bash $(CURDIR)/configure $(CONFFLAGS)
ifeq (linux,$(DEB_HOST_ARCH_OS))
	if grep -q APR_HAS_POSIXSEM_SERIALIZE.*0 $(BUILDDIR)/include/apr.h ;\
	then \
		echo "WARNING: This is Linux but configure did not detect POSIX semaphores." ;\
		if ! df /dev/shm/.|grep -q ^tmpfs ;\
		then \
			echo "ERROR: POSIX semaphores not usable and /dev/shm not mounted." ;\
			echo "ERROR: Aborting." ;\
			echo "HINT: If you are using pbuilder or cowbuilder, add /dev/shm to BINDMOUNTS" ;\
			echo "HINT: in pbuilderrc" ;\
			exit 1 ;\
		fi ;\
	fi
endif


#
# build
#
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

override_dh_auto_build:
	$(MAKE) -j$(NUMJOBS) -C $(BUILDDIR) all dox

#
# test
#

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))

# the testsockets test will fail on vservers (no 127.0.0.1) or if ipv6 is
# enabled in the kernel but not configured on any interface
IGNORE_TESTSOCK = $(shell IGN=false; \
	/sbin/ifconfig|grep -q 127.0.0.1 || IGN=true; \
	grep -q ipv6 /proc/net/protocols && ( /sbin/ifconfig|grep -q inet6 || IGN=true ) ; \
	echo $$IGN )

override_dh_auto_test:
	$(MAKE) -C $(BUILDDIR)/test -j$(NUMJOBS) all
	cd $(BUILDDIR)/test && ./testall -v testsockets testsock || $(IGNORE_TESTSOCK)
	cd $(BUILDDIR)/test && ( ulimit -S -s 8192 ; ./testall -v testatomic)
	cd $(BUILDDIR)/test && ./testall -v -x testsockets testsock testatomic

else
override_dh_auto_test:

endif


#
# install
#
override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
	perl -p -i -e "s,^dependency_libs=.*,dependency_libs=''," debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libapr-1.la
	if ! head -n 1 debian/tmp/usr/share/apr-1.0/build/libtool | grep -q /bin/bash ; then \
		echo ERROR: The built libtool uses /bin/sh instead of /bin/bash ; \
		exit 1 ; \
	fi

override_dh_strip:
	dh_strip --dbg-package=libapr1-dbg

override_dh_makeshlibs:
	dh_makeshlibs -- -Idebian/symbols.$(DEB_HOST_ARCH_OS)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)
	for f in $(SAVE_FILES) ; do [ ! -e $$f.dr-orig ] || mv $$f.dr-orig $$f ; done

=== debian/watch ===
version=3
http://www.apache.org/dist/apr/apr-(1\..*)\.tar\.gz

## apr 1.5.1

=== debian/changelog ===
apr (1.5.1-3) unstable; urgency=medium

  [Helmut Grohne]
  * Check for libtoolize rather than libtool. Closes: #761732

  [ Stefan Fritsch ]
  * Update Vcs-Git URL in control file.

 -- Stefan Fritsch <sf@debian.org>  Sat, 20 Sep 2014 22:21:24 +0200

apr (1.5.1-2) unstable; urgency=medium

  * Backport build fix from upstream SVN to avoid building some parts
    twice. This should also fix the build failure on amd64.
  * Fix build problem with new make.

 -- Stefan Fritsch <sf@debian.org>  Mon, 12 May 2014 23:21:06 +0200

apr (1.5.1-1) unstable; urgency=low

  * New upstream version

 -- Stefan Fritsch <sf@debian.org>  Thu, 01 May 2014 10:37:50 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper (>= 9), autoconf, autotools-dev, mawk, uuid-dev, doxygen, netbase, net-tools, libtool (>= 2), python, libsctp-dev [linux-any]
 Standards-Version: 3.9.5
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-apache/apr.git
-Vcs-Git: git://git.debian.org/git/pkg-apache/apr.git
+Vcs-Git: git://anonscm.debian.org/pkg-apache/apr.git
 Homepage: http://apr.apache.org/
 
 Package: libapr1

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 # The 'build' target needs special handling because there there is a directory
 # named 'build'.
 .PHONY: build
-build %:
+%:
 	dh $@ -B$(BUILDDIR) --parallel --with autotools_dev
 
 #

## apr 1.5.2

=== debian/changelog ===
apr (1.5.2-3) unstable; urgency=medium

  * Use flock for apr_file_lock()/_unlock(). This has the advantage that
    the lock is per FD and not per process. On the other hand, locking over
    NFS may not work any more for non-Linux kernels. Closes: #752872
  * Add debug output for strange test failure on reproducible.debian.net.

 -- Stefan Fritsch <sf@debian.org>  Thu, 20 Aug 2015 13:47:59 +0200

apr (1.5.2-2) unstable; urgency=medium

  * Remove the buildhost's hostname from libtool for reproducible builds.
  * Fix ipv6 address comparison in apr_mcast_interface/apr_mcast_join.
    Thanks to Andre Naujoks <nautsch2 gmail com> for the patch.
    Closes: #759534

 -- Stefan Fritsch <sf@debian.org>  Mon, 17 Aug 2015 18:49:41 +0200

apr (1.5.2-1) unstable; urgency=medium

  * New upstream version
  * Don't ship useless *.md5 doxygen files.
  * Bump Standards-Version (no changes)

 -- Stefan Fritsch <sf@debian.org>  Sat, 15 Aug 2015 16:39:04 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
 Uploaders: Peter Samuelson <peter@p12n.org>, Stefan Fritsch <sf@debian.org>
 Build-Depends: debhelper (>= 9), autoconf, autotools-dev, mawk, uuid-dev, doxygen, netbase, net-tools, libtool (>= 2), python, libsctp-dev [linux-any]
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-apache/apr.git
 Vcs-Git: git://anonscm.debian.org/pkg-apache/apr.git
 Homepage: http://apr.apache.org/

=== debian/rules ===
--- 
+++ 
@@ -105,6 +105,7 @@
 
 override_dh_auto_build:
 	$(MAKE) -j$(NUMJOBS) -C $(BUILDDIR) all dox
+	find debian/build/docs/dox/html -name \*.md5 -delete
 
 #
 # test
@@ -137,6 +138,8 @@
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/tmp
 	perl -p -i -e "s,^dependency_libs=.*,dependency_libs=''," debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libapr-1.la
+	# Remove hostname to make build reproducible
+	perl -p -i -e 's/Libtool was configured on host.*//' debian/tmp/usr/share/apr-1.0/build/libtool
 	if ! head -n 1 debian/tmp/usr/share/apr-1.0/build/libtool | grep -q /bin/bash ; then \
 		echo ERROR: The built libtool uses /bin/sh instead of /bin/bash ; \
 		exit 1 ; \

## apr 1.6.2

=== debian/changelog ===
apr (1.6.2-1) unstable; urgency=medium

  * New upstream version
  * Remove Peter Samuelson from uploaders. Thanks for your work in the past.
    Closes: #852222

 -- Stefan Fritsch <sf@debian.org>  Fri, 04 Aug 2017 16:39:16 +0200

apr (1.5.2-5) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #840891)
    + Annotate Build-Depends: python with :any
    + cross.patch: Build gen_test_char with the build arch compiler

 -- Stefan Fritsch <sf@debian.org>  Sat, 10 Dec 2016 17:41:09 +0100

apr (1.5.2-4) unstable; urgency=medium

  [ Jean-Michel Vourgère ]
  * Update Vcs-Browser: address.
  * d/watch: Check gpg signature of upstream source.

  [ Stefan Fritsch ]
  * Run buildconf with LC_ALL=C to fix some reproducible build issues.
  * Bump Standards-Version (no changes)

 -- Stefan Fritsch <sf@debian.org>  Sun, 29 May 2016 15:44:28 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: libs
 Priority: optional
 Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
-Uploaders: Peter Samuelson <peter@p12n.org>, Stefan Fritsch <sf@debian.org>
-Build-Depends: debhelper (>= 9), autoconf, autotools-dev, mawk, uuid-dev, doxygen, netbase, net-tools, libtool (>= 2), python, libsctp-dev [linux-any]
-Standards-Version: 3.9.6
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-apache/apr.git
+Uploaders: Stefan Fritsch <sf@debian.org>
+Build-Depends: debhelper (>= 9), autoconf, autotools-dev, mawk, uuid-dev, doxygen, netbase, net-tools, libtool (>= 2), python:any, libsctp-dev [linux-any]
+Standards-Version: 3.9.8
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-apache/apr.git
 Vcs-Git: git://anonscm.debian.org/pkg-apache/apr.git
 Homepage: http://apr.apache.org/

## apr 1.6.3

=== debian/changelog ===
apr (1.6.3-2) unstable; urgency=medium

  * Avoid empty build target, fixes FTBFS. Thanks to Niels Thykier for the
    patch. Closes: #888593
  * Drop deprecated autotools-dev sequence. Thanks to Niels Thykier for the
    patch.
  * Switch to debhelper compat level 11 and use dh_autoreconf.
  * Include NOTICE file in packages, as required by license.
  * Bump Standards-Version (no changes).

 -- Stefan Fritsch <sf@debian.org>  Sun, 25 Feb 2018 16:35:41 +0100

apr (1.6.3-1) unstable; urgency=medium

  * New upstream version
    - Fixes CVE-2017-12613: Out-of-bounds array deref in apr_time_exp*
      functions. Closes: #879708
  * Replace obsolete priority extra with optional.

 -- Stefan Fritsch <sf@debian.org>  Mon, 06 Nov 2017 20:07:42 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
 Uploaders: Stefan Fritsch <sf@debian.org>
-Build-Depends: debhelper (>= 9), autoconf, autotools-dev, mawk, uuid-dev, doxygen, netbase, net-tools, libtool (>= 2), python:any, libsctp-dev [linux-any]
-Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 11), autoconf, mawk, uuid-dev, doxygen, netbase, net-tools, libtool (>= 2), python:any, libsctp-dev [linux-any]
+Standards-Version: 4.1.3
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-apache/apr.git
 Vcs-Git: git://anonscm.debian.org/pkg-apache/apr.git
 Homepage: http://apr.apache.org/
@@ -36,7 +36,6 @@
 Package: libapr1-dbg
 Architecture: any
 Section: debug
-Priority: extra
 Multi-Arch: same
 Depends: libapr1 (= ${binary:Version}), ${misc:Depends}
 Description: Apache Portable Runtime Library - Debugging Symbols

=== debian/rules ===
--- 
+++ 
@@ -14,8 +14,12 @@
 # The 'build' target needs special handling because there there is a directory
 # named 'build'.
 .PHONY: build
+# The build target must not be empty.  Sadly because of how make
+# works, we have do duplicate the target in this case.
+build:
+	dh $@ -B$(BUILDDIR)
 %:
-	dh $@ -B$(BUILDDIR) --parallel --with autotools_dev
+	dh $@ -B$(BUILDDIR)
 
 #
 # configure
@@ -69,13 +73,11 @@
   endif
 endif
 
-# files that are modified by buildconf and need to be restored during clean
-SAVE_FILES := configure build/libtool.m4 build/ltmain.sh
+override_dh_autoreconf:
+	LC_ALL=C dh_autoreconf ./buildconf
 
 override_dh_auto_configure:
 	mkdir -p $(BUILDDIR)/docs
-	for f in $(SAVE_FILES) ; do [ -e $$f.dr-orig ] || cp -p $$f $$f.dr-orig ; done
-	./buildconf
 	# We need to force the use of bash here. Otherwise, if apr is built with
 	# /bin/sh -> /bin/bash, the resulting libtool will not work on systems
 	# where /bin/sh -> /bin/dash.
@@ -154,4 +156,3 @@
 override_dh_auto_clean:
 	dh_auto_clean
 	rm -rf $(BUILDDIR)
-	for f in $(SAVE_FILES) ; do [ ! -e $$f.dr-orig ] || mv $$f.dr-orig $$f ; done
